<?php
    
    $seed = time();
    
    $to = "info@shieldx2.com";
    
    $subject = $_POST[ "form-title" ];
    
    function test_input( $data ) {
       $data = trim( $data );
       $data = stripslashes( $data );
       $data = htmlspecialchars( $data );
       return $data;
    }
    
    $email = test_input( $_POST[ "email" ] );
    if ( !filter_var( $email, FILTER_VALIDATE_EMAIL ) ) {
        header( "Location: http://www.shieldx2.com/failure/" );
    }
    
    $credit_card = array(
        "form-title",
        "additional-5-95-charge",
        "first-name-cc",
        "last-name-cc",
        "number-cc",
        "cvv-cc",
        "exp-month-cc",
        "exp-year-cc",
        "return",
        "return-fail"
    );
    
    $string = $process = array();
    foreach ( $_POST as $key => $value ) {
        if ( !in_array( $key, $credit_card ) ) {
            $string[] = "<b>" . ucwords( str_replace( "_", " ", str_replace( "-", " ", $key ) ) ) . "</b>: " . ( ( $value != "" ) ? $value : "-" );
        }
        else {
            $process[ $key ] = $value;
        }
    }
    $string = implode( "<br>", $string );
    
    $claim = "";
    if ( $subject == "Submit A Claim" ) {
        $to = "claims@shieldx2.com";
        $adc = ( $_POST[ "additional-5-95-charge" ] == "" ) ? "No" : "Yes";
        $claim .= "<h4>Claim #: " . $seed . " ( You can match this number on the Authorize.net transactions )</h4>";
        $claim .= "<p>Additional $5.95 charge to receive a new Shieldx2Plus protective case: <b>" . $adc . "</b></p>";
    }
    else {
        $claim = "";
    }
    
    $activation = "";
    if ( $subject == "Activate Your Shield" ) {
        $act = $_POST[ "activation-code" ];
        $claim .= "<h4>Activation Code #: " . $act . " ( You can match this number on the Manage Serial Codes page )</h4>";
    }
    else {
        $activation = "";
    }
    
    
    $message = <<<____EOF
        
        <html>
            <body>
                <h3>{$subject}</h3>
                {$claim}
                {$activation}
                <p>{$string}</p>
            </body>
        </html>
        
____EOF;
    
    $headers = array();
    $headers[] = "From: info@shieldx2.com";
    $headers[] = "Content-type: text/html";
    
    if ( $subject == "Submit A Claim" ) {
        /* $info = array(
            "site_id" => "5",
            "cellnumber" => "",
            "esnimei" => "",
            "carrier" => "",
            "manufacturer" => "",
            "model" => "",
            "first_name" => $_POST[ "first-name" ],
            "last_name" => $_POST[ "last-name" ],
            "address_1" => $_POST[ "address-1" ],
            "address_2" => $_POST[ "address-2" ],
            "city" => $_POST[ "city" ],
            "state" => $_POST[ "state" ],
            "postal_code" => $_POST[ "zip" ],
            "country" => $_POST[ "country" ],
            "home_phone" => $_POST[ "alternate-phone" ],
            "email" => $_POST[ "email" ],
            "ipaddr" => "",
            "http_referer" => "",
            "http_user_agent" => "",
            "api_key" => "VVAPe6RcrHKR7YgFxnb7txzHs6klMZkK9ZxRCtbZwDI"
        );
        
        print_r( $_POST );
        
        $c = new cURL();
        $r = $c->post( "http://test.api.mobile1protect.com/account/5/members", $info );
        
        print_r( $r );
        
        die; */
        
        $return = process_card( $process, $_POST );
        if ( $return[ 0 ] == '"1"' ) {
            mail( $to, $subject,  htmlspecialchars_decode($message), implode( "\r\n", $headers ) );
            $text = file_get_contents( "post-submit-a-claim" );
            mail( $_POST[ "email" ], "Restore your Mobile Life!", $text, implode( "\r\n", $headers ) );
            header( "Location: " . $_POST[ "return" ] . "?log=" . base64_encode( $return[ 3 ] . "<br><br>Thank You. You have been successfully charged $ " . ( ( $_POST[ "additional-5-95-charge" ] == "" ) ? "25.00" : "30.95" ) . " for Your ShieldX2Plus Claim!" ) );
        }
        else {
            header( "Location: " . $_POST[ "return-fail" ] . "?log=" . base64_encode( $return[ 3 ] ) );
        }
    }
    else {
        if ( $subject == "Activate Your Shield" ) {
            require_once( "app/Mage.php" );
            Mage::app( "default" );
            $codes = Mage::getModel( "serialcodes/serialcodes" )->getCollection()->addFieldToFilter( "code", array( "eq" => $_POST[ "activation-code" ] ) )->load();
            if ( count( $codes ) == 1 ) {
                foreach ( $codes as $code ) {
                    if ( $code->getStatus() == 0 ) {
                        $code->setStatus( 1 )->save();
                        echo "Your ShieldX2Plus has been activated! We thank you!";
                        mail( $to, $subject, htmlspecialchars_decode($message), implode( "\r\n", $headers ) );
                    }
                    else {
                        header( "Location: " . $_POST[ "return-fail" ] . "?log=" . base64_encode( "The ShieldX2Plus has been already activated! Please check again!" ) );
                    }
                }
            }
            else {
                header( "Location: " . $_POST[ "return-fail" ] . "?log=" . base64_encode( "The activation code you've entered does not exist." ) );
            }
        }
        elseif ( $subject == "Transfer A Plan" ) {
            $m = <<<____________EOF
                <html>
                    <body>
                        <p><img src="http://www.shieldx2.com/skin/frontend/default/simplegreat/images/logo.png" width="200px"></p>
                        <h3>Congratulations on your new phone or tablet.</h3>
                        <p>We have all of your new information now on your new phone or tablet, and you are now Covered for the remainder of your policy!  Please remember to put your new Shieldx2 on your phone or tablet when you receive it.</p>
                        <p>Reliable Product Protection Policy for Your Smartphone and Tablet!</p>
                        <p>Thanks again,<br>Your friends from Shieldx2Plus</p>
                    </body>
                </html>
____________EOF;
            mail( $_POST[ "email" ], "Congratulations on your new phone or tablet!", htmlspecialchars_decode($m), implode( "\r\n", array( "From: support@shieldx2.com", "Content-type: text/html" ) ) );
            mail( $to, $subject, htmlspecialchars_decode($message), implode( "\r\n", $headers ) );
            header( "Location: " . $_POST[ "return" ] );
        }
        elseif ( $subject != "" ) {
            mail( $to, $subject, htmlspecialchars_decode($message), implode( "\r\n", $headers ) );
            header( "Location: " . $_POST[ "return" ] );
        }
    }
    
    function process_card( $process, $general ) {
        global $seed;
        $post_values = array(
            "x_login" => "4jYP963f2L",
            "x_tran_key" => "6f5p32V2BvK79M7j",
            "x_version" => "3.1",
            "x_delim_data" => "TRUE",
            "x_delim_char" => "|",
            "x_relay_response" => "FALSE",
            "x_type" => "AUTH_CAPTURE",
            "x_method" => "CC",
            "x_card_num" => $process[ "number-cc" ],
            "x_exp_date" => $process[ "exp-month-cc" ] . $process[ "exp-year-cc" ],
            "x_amount" => ( $process[ "additional-5-95-charge" ] == "OK" ) ? "30.95" : "25.00",
            "x_description" => "Claim #: " . $seed,
            "x_first_name" => $process[ "first-name-cc" ],
            "x_last_name" => $process[ "last-name-cc" ],
            "x_address" => $general[ "address-1" ] . " " . $general[ "address-2" ],
            "x_state" => $general[ "state" ],
            "x_zip" => $general[ "zip" ],
            "x_country" => $general[ "country" ]
        );
        $post_string = "";
        foreach( $post_values as $key => $value ) {
            $post_string .= "$key=" . urlencode( $value ) . "&";
        }
        $post_string = rtrim( $post_string, "& " );
        $request = curl_init( "https://secure.authorize.net/gateway/transact.dll" );
        curl_setopt( $request, CURLOPT_HEADER, 0 );
        curl_setopt( $request, CURLOPT_RETURNTRANSFER, 1 );
        curl_setopt( $request, CURLOPT_POSTFIELDS, $post_string );
        curl_setopt( $request, CURLOPT_SSL_VERIFYPEER, FALSE );
        $post_response = curl_exec( $request );
        curl_close ( $request );
        $response_array = explode( $post_values[ "x_delim_char" ], $post_response );
        return $response_array;
    }
    
    class cURL {
        var $options = array(
            CURLOPT_HEADER => FALSE,
            CURLOPT_RETURNTRANSFER => TRUE,
            CURLOPT_SSL_VERIFYPEER => FALSE
        );
        private function request( $object, $option ) {
            $options = $this->options;
            foreach ( $option as $key => $value ) {
                $options[ $key ] = $value;
            }
            curl_setopt_array( $object, $options );
            curl_exec( $object );
            $request[ 'code' ] = curl_getinfo( $object, CURLINFO_HTTP_CODE );
            $request[ 'content' ] = curl_exec( $object );
            $request[ 'error' ] = curl_errno( $object );
            curl_close( $object );
            return ( object ) $request;
        }
        function get( $url = "", $data = array(), $option = array() ) {
            if ( $url === "" ) {
                die( "URL cannot be blank." );
            }
            $object = curl_init( $url . "?" . http_build_query( $data ) );
            return $this->request( $object, $option );
        }
        function post( $url = "", $data = array(), $option = array() ) {
            if ( $url === "" ) {
                die( "URL cannot be blank." );
            }
            $option[ CURLOPT_POST ] = TRUE;
            $option[ CURLOPT_POSTFIELDS ] = $data;
            $object = curl_init( $url );
            return $this->request( $object, $option );
        }
    }
	
?>
